<template>
  <div class="sw-gs-widget-cart-insights">
    <SfLoader class="widget-loader" :loading="isLoading" v-if="isLoading"/>
    <template v-else>
      <div class="cart-insights-tables-wrapper">
        <div class="cart-insights-table">
          <div class="cart-insights-table-heading">{{ $t('Top selling products by quantity') }}</div>
          <div class="cart-insights-table-body">
            <div v-if="topProductsByQuantity && topProductsByQuantity.length >= 1">
              <div class="cart-insights-table-header cart-insights-table-row">
                <div class="cart-insights-table-col is-pos">#0</div>
                <div class="cart-insights-table-col is-product">{{ $t('Product') }}</div>
                <div class="cart-insights-table-col is-quantity">{{ $t('Quantity') }}</div>
              </div>

              <div v-for="(product, index) in topProductsByQuantity" class="cart-insights-table-row">
                <div class="cart-insights-table-col is-pos">#{{ index + 1 }}</div>
                <div class="cart-insights-table-col is-product">{{ getTranslatedProperty(product, 'name') }}</div>
                <div class="cart-insights-table-col is-quantity">{{ product.value }}</div>
              </div>
            </div>
            <div v-else>
              {{ $t('No products yet.') }}
            </div>
          </div>
        </div>

        <div class="cart-insights-table">
          <div class="cart-insights-table-heading">{{ $t('Top selling products by revenue') }}</div>
          <div class="cart-insights-table-body">
            <div v-if="topProductsByRevenue && topProductsByRevenue.length >= 1">
              <div class="cart-insights-table-header cart-insights-table-row">
                <div class="cart-insights-table-col is-pos">#0</div>
                <div class="cart-insights-table-col is-product">{{ $t('Product') }}</div>
                <div class="cart-insights-table-col is-total">{{ $t('Total') }}{{ $t('*') }}</div>
              </div>

              <div v-for="(product, index) in topProductsByRevenue" class="cart-insights-table-row">
                <div class="cart-insights-table-col is-pos">#{{ index + 1 }}</div>
                <div class="cart-insights-table-col is-product">{{ getTranslatedProperty(product, 'name') }}</div>
                <div class="cart-insights-table-col is-total">{{ formatPrice(product.value) }}</div>
              </div>
              <div class="cart-insights-table-row">
                <span class="price-hint">{{ $t('*This is the net price.') }}</span>
              </div>
            </div>
            <div v-else>
              {{ $t('No products yet.') }}
            </div>
          </div>
        </div>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
  import {SfLoader} from "@storefront-ui/vue";
  import {onMounted} from '@vue/composition-api';
  import {useCartInsights} from "../../logic/composables/widgets/useCartInsights";
  import { usePriceFilter } from "../../logic/composables/usePriceFilter";
  import {getTranslatedProperty} from "@shopware-pwa/helpers";

  export default {
    name: "SwGsCartInsights",
    components: {
      SfLoader
    },
    setup({}, {}) {
      const {
        loadCartInsights,
        topProductsByQuantity,
        topProductsByRevenue,
        isLoading
      } = useCartInsights();

      const { formatPrice } = usePriceFilter();

      onMounted(async () => {
        await loadCartInsights();
      })

      return {
        isLoading,
        topProductsByQuantity,
        topProductsByRevenue,
        formatPrice,
        getTranslatedProperty
      }
    },
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .widget-loader {
    height: 50px;
  }

  .cart-insights-table-heading {
    font-size: var(--font-size--sm);
    padding: 3px 0;
    margin-bottom: 3px;
    border-bottom: 2px solid var(--c-primary);
  }

  .cart-insights-table:not(:last-of-type) {
    margin-bottom: 20px;
  }

  .cart-insights-table-body {
    font-size: var(--font-size--sm);
  }

  .cart-insights-table-row {
    display: flex;
    margin: 0 -5px;
  }

  .cart-insights-table-col {
    padding: 0 5px;

    &.is-pos {
      width: 10%;
    }

    &.is-product {
      width: 60%;
    }

    &.is-quantity,
    &.is-total {
      width: 30%;
      text-align: right;
    }
  }

  .cart-insights-table-header {
    font-weight: 500;

    .cart-insights-table-col.is-pos {
      opacity: 0; // placeholder
    }
  }

  .price-hint {
    font-size: 12px;
    padding: 5px;
    margin-left: auto;
  }
</style>
